SystemOrganization addCategory: #Forum!
SystemOrganization addCategory: #'Forum-Announcements'!
SystemOrganization addCategory: #'Forum-Application'!
SystemOrganization addCategory: #'Forum-Model'!
SystemOrganization addCategory: #'Forum-Tests'!

DEPageChoice subclass: #FOAgileOverflow
	instanceVariableNames: 'loginName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAgileOverflow class methodsFor: 'class initialization' stamp: 'StephanEggermont 4/3/2013 13:36'!
initialize
	"Registers this application as webpage
		FOAgileOverflow initialize.
	"
	super initialize.
	(WAAdmin register: self asApplicationAt: 'AgileOverflow')
		preferenceAt: #sessionClass
			put: DESession;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: FOFileLibrary;
		yourself
! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
askQuestion
	self announce: FOGoAskQuestion! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
askQuestion2
	self announce: FOGoAskQuestion2! !

!FOAgileOverflow methodsFor: 'initialization' stamp: 'DiegoLont 8/21/2011 14:53'!
initialize 
	super initialize.
	self addPage: FOHome new announcement: DEGoHome.
	self addPage: FOAskQuestion new announcement: FOGoAskQuestion.
	self addPage: FOAskQuestion2 new announcement: FOGoAskQuestion2.
	self addPage: FOAllQuestions new announcement: FOGoAllQuestions.
	self addPage: FOViewQuestion new announcement: FOGoViewQuestion symbol: #question.
! !

!FOAgileOverflow methodsFor: 'user management' stamp: 'StephanEggermont 10/3/2011 11:53'!
login
	self user: (FOModel default authorNamed: loginName password: password).! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:06'!
loginName
	^ loginName! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:06'!
loginName: anObject
	loginName := anObject! !

!FOAgileOverflow methodsFor: 'user management' stamp: 'StephanEggermont 10/3/2011 12:06'!
logout
	self user: nil! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:42'!
password
	^ password! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:42'!
password: anObject
	password := anObject! !

!FOAgileOverflow methodsFor: 'user management' stamp: 'StephanEggermont 10/3/2011 12:03'!
register
	self user: (FOModel default registerAuthor: loginName password: password).! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/18/2010 11:29'!
renderBottomOn: canvas! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 5/19/2011 13:52'!
renderContentOn: canvas
	canvas form
		with: [
			self renderTopOn: canvas;
				renderHeaderOn: canvas;
				renderMainOn: canvas;
				renderBottomOn: canvas]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 4/29/2011 16:47'!
renderHeaderOn: canvas
	canvas div 
		class: 'page-header';
		with: [
			canvas div 
				class: 'home';
				with: [
					canvas anchor 
						callback: [self goHome];
						with: 'AgileOverflow']]
! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/3/2011 11:55'!
renderLoginOrRegisterOn: canvas
	canvas textInput on: #loginName of: self.
	canvas passwordInput on: #password of: self.
	canvas submitButton on: #login of: self.
	canvas submitButton on: #register of: self.! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 5/19/2011 15:06'!
renderMainOn: canvas
	canvas div
		class: 'top';
		with: [self renderQuestionHeaderOn: canvas].
	canvas div 
		class: 'mainleft';
		with: [canvas render: self currentPage]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/18/2010 11:25'!
renderMetaOn: canvas
	canvas span
		class: 'metaspan';
		with: [
			canvas text: 'chat | meta | about | faq'.]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/3/2011 11:56'!
renderQuestionHeaderOn: canvas
	self isLoggedIn ifTrue: [
		canvas submitButton on: #askQuestion of: self.
		canvas submitButton on: #askQuestion2 of: self]
	ifFalse: [
		self renderLoginOrRegisterOn: canvas].
	canvas submitButton on: #viewAllQuestions of: self.
	canvas break.
	canvas text: 'Top Questions'! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 4/28/2011 21:54'!
renderSearchOn: canvas
	canvas span 
		class: 'searchspan';
		with: [
			canvas textInput 
				on: #search of: self.
			]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/18/2010 11:44'!
renderTopOn: canvas
	canvas div
		class: 'topbar';
		with: [
			canvas span 
				class: 'hlinks';
				with: [
					self renderUserOrLoginOn: canvas.
					self renderMetaOn: canvas.
					self renderSearchOn: canvas] ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/3/2011 12:06'!
renderUserOrLoginOn: canvas
	canvas span
		class: 'userspan';
		with: [
			canvas text: self username.
			self ifLoggedIn: [
			canvas submitButton on: #logout of: self]]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/18/2010 11:26'!
search
	^'search'! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 10/18/2010 11:26'!
search: aString! !

!FOAgileOverflow methodsFor: 'updating' stamp: 'StephanEggermont 5/19/2011 13:46'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'AgileOverflow'
! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
viewAllQuestions
	self announce: FOGoAllQuestions! !

TestCase subclass: #TestAnswer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

TestCase subclass: #TestAuthor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCanAnswerQuestion
	|model author question answer|
	model := FOModel new.
	author := model newAuthor.
	question := author newQuestion.
	answer := question newAnswer: author.
	self assert: author equals: answer author.
	self assert: (question hasAnswer: answer)! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCanAskQuestion
	|model author question|
	model := FOModel new.
	author := model newAuthor.
	question := author newQuestion.
	self assert: author equals: question author.
	self assert: (model hasQuestion: question)! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorHasUsername
	|author|
	author := FOAuthor new
		userName: 'Kent';
		yourself.
	self assert: 'Kent' equals: author userName! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorKnowsModel
	|author model|
	model := FOModel new.
	author := model newAuthor.
	self assert: author model notNil.
	self deny: FOModel default = author model.
	self assert: model equals: author model! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 23:53'!
testAuthorNamedKnowsModel
	|author model|
	model := FOModel new.
	author := model authorNamed: 'Martin'.
	self assert: author model notNil.
	self deny: FOModel default = author model.
	self assert: model equals: author model! !

TestCase subclass: #TestModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelCanFindAuthorsByName
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		yourself.
	self assert: (model authorNamed: 'Joel') equals:author! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 11:44'!
testModelCanFindAuthorsByNameAndPassword
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		password: 'leoJ';
		yourself.
	self assert: (model authorNamed: 'Joel') equals:author! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testModelDoesntKnowOtherQuestions
	|model question| 
	model := FOModel new.
	question := FOQuestion new.
	self deny: (model hasQuestion: question).
! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsAuthors
	|model author| 
	model := FOModel new.
	author := model newAuthor.
	self assert: (model authors size = 1).
	self assert: (model authors includes: author)! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsQuestions
	|model question| 
	model := FOModel new.
	question := model newQuestion.
	self assert: (model hasQuestion: question).
	self assert: (model questions size = 1).! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsTags
	|model tag| 
	model := FOModel new.
	tag := model newTag.
	self assert: (model tags size = 1).
	self assert: (model tags includes: tag)! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsTheNumberOfQuestions
	|model question| 
	model := FOModel new.
	self assert: (model questions size = 0).
	question := model newQuestion.
	self assert: (model questions size = 1).
	question := model newQuestion.
	self assert: (model questions size = 2).
	question := model newQuestion.
	self assert: (model questions size = 3).! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 12:00'!
testModelReturnsNewAuthorWhenRegistering
	|model author| 
	model := FOModel new.
	author := model registerAuthor: 'Joel' password: 'leoJ'.
	self assert: (model authors size = 1).
	self assert: (model authors includes: author)! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 11:46'!
testModelReturnsNilIfPasswordWrong
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		password: 'leoJ';
		yourself.
	self assert: (model authorNamed: 'Joel' password: 'leoJ') equals: author.
	self assert: (model authorNamed: 'Joel' password: 'leo') equals: nil.
	! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testTheSharedModelExists
	|model|
	model := FOModel default.
	self assert: (model questions size>= 0)! !

TestCase subclass: #TestPost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCannotVoteOwnPost
	|post author|
	post := FOPost new.
	post author: author.
	post voteUp: author.
	self assert: 0 equals: post voteSize.
	post voteDown: author.
	self assert: 0 equals: post voteSize! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostHasContent
	|post|
	post := FOPost new
		content: 'Question, answer or comment?';
		yourself.
	self assert: 'Question, answer or comment?' equals: post content! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 16:15'!
testPostShouldShowDefaultAuthorName
	|post |
	post := FOPost new.
	self assert: 'Anonymous' equals: post authorName
	! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 16:17'!
testPostShouldShowRealAuthorName
	|post author|
	post := FOPost new.
	author := FOAuthor new
		userName: 'Willem';
		yourself.
	post author: author.
	self assert: 'Willem' equals: post authorName
	! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostStartsWithZeroVotes
	|post|
	post := FOPost new.
	self assert: 0 equals: post voteSize! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:09'!
testPostVoteSize
	|post author1 author2|
	post := FOAnswer new.
	author1 := FOAuthor new.
	author2 := FOAuthor new.
	self assert: 0 equals: post voteSize.
	post voteUp: author1.
	self assert: 1 equals: post voteSize.
	post voteDown: author2.
	self assert: 2 equals: post voteSize.
	
! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostVoteValue
	|post author1 author2|
	post := FOPost new.
	author1 := FOAuthor new.
	author2 := FOAuthor new.
	self assert: 0 equals: post voteValue.
	post voteUp: author1.
	self assert: 1 equals: post voteValue.
	post voteDown: author2.
	self assert:  0 equals: post voteValue.
	
! !

TestCase subclass: #TestQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testAnswerCanBeAccepted
	|question answer|
	question := FOQuestion new.
	answer := question newAnswer.
	self deny: question hasAcceptedAnswer.
	answer accept.
	self assert: question hasAcceptedAnswer.
! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testOneAnswerIsNotUnanswered
	|question answer |
	question := FOQuestion new.
	answer := question newAnswer.
	self assert: question isAnswered! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testOnlyOneAnswerCanBeAccepted
	|question answer answer2|
	question := FOQuestion new.
	answer := question newAnswer.
	answer2 := question newAnswer.
	self assert: (question canAccept: answer).
	self assert: (question canAccept: answer2).
	answer accept.
	self assert: question hasAcceptedAnswer.
	self deny: (question canAccept: answer2).! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionHasRightNumberOfAnswersString
	|question answer|
	question := FOQuestion new.
	self assert: '0 Answers' equals: question answerSizeString.
	answer := question newAnswer.
	self assert: '1 Answer' equals: question answerSizeString.
	answer := question newAnswer.
	self assert: '2 Answers' equals: question answerSizeString.! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 22:24'!
testQuestionHasTagString
	|question|
	question := FOQuestion new
		addTag: (FOTag new 
			description: 'one';
			yourself);
		addTag: (FOTag new
			description: 'two';
			yourself);
		yourself.
	self assert: 'one two' equals: question tagString ! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionHasTitle
	|question|
	question := FOQuestion new
		title: 'How does this work?';
		yourself.
	self assert: 'How does this work?' equals: question title ! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsAnswers
	|question answer|
	question := FOQuestion new.
	answer := question newAnswer.
	self assert: (question hasAnswer: answer).
	answer := FOAnswer new.
	self deny: (question hasAnswer: answer)
! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsComments
	|question comment|
	question := FOQuestion new.
	comment := question newComment.
	self assert: (question hasComment: comment).
	comment := FOComment new.
	self deny: (question hasComment: comment).
	! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsNumberOfAnswers
	|question answer|
	question := FOQuestion new.
	self assert: 0 equals: question answerSize.
	answer := question newAnswer.
	self assert: 1 equals: question answerSize.! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowstags
	|tag question|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.		
	question := FOQuestion new
		addTag: tag;
		yourself.
	self assert: 1 equals: question tags size.
	self assert: (question hasTag: tag)
		! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionStartsUnaccepted
	|question|
	question := FOQuestion new.
	self deny: question hasAcceptedAnswer! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionStartsUnanswered
	|question|
	question := FOQuestion new.
	self deny: question isAnswered! !

TestCase subclass: #TestTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestTag methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testTagHasDescription
	|tag|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.
	self assert: 'Smalltalk' equals: tag description! !

!TestTag methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testTagKnowsQuestions
	|tag question|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.		
	self assert: 0 equals: tag questions size.
	question := FOQuestion new
		addTag: tag;
		yourself.
	self assert: 1 equals: tag questions size.
		! !

DEComponent subclass: #FOAllQuestions
	instanceVariableNames: 'questionsReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAllQuestions methodsFor: 'hooks' stamp: 'StephanEggermont 5/19/2011 14:59'!
children
	^Array with: self questionsReport! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'StephanEggermont 1/28/2013 16:03'!
createQuestionsReport
	^DEReportBuilder new
		subject: FOQuestion;
		propertySymbol: #reportFields;
		createReportFrom: self! !

!FOAllQuestions methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 14:57'!
questionsReport
	^questionsReport ifNil: [questionsReport := self createQuestionsReport]! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'StephanEggermont 5/19/2011 14:55'!
renderContentOn: canvas
	self renderQuestionsOn: canvas
	! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'StephanEggermont 5/19/2011 14:56'!
renderQuestionsOn: canvas
	self questionsReport rows: (FOModel default questions).
	canvas render: self questionsReport! !

!FOAllQuestions methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:00'!
showDetails: aQuestion
	^ self announce: (FOGoViewQuestion on: aQuestion)! !

DEComponent subclass: #FOAskQuestion
	instanceVariableNames: 'title contents tags author question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents
	^ contents! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents: anObject
	contents := anObject! !

!FOAskQuestion methodsFor: 'actions' stamp: 'DiegoLont 8/21/2011 14:53'!
postYourQuestion
	author := self user.
	FOModel default newQuestion
		author: author;
		title: title;
		content: contents.
	self announce: DEGoHome
		! !

!FOAskQuestion methodsFor: 'rendering' stamp: 'StephanEggermont 4/28/2011 22:01'!
renderContentOn: canvas
	canvas form:[
		canvas label: 'Title'.
		canvas textInput on: #title of: self.
		canvas break.
		canvas textArea on: #contents of: self.
		canvas break.
		canvas label: 'Tags'.
		canvas textInput on: #tags of: self.
		canvas break.
		canvas submitButton on: #postYourQuestion of: self]! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags
	^ tags! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags: anObject
	tags := anObject! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title
	^ title! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title: anObject
	title := anObject! !

DEComponent subclass: #FOAskQuestion2
	instanceVariableNames: 'editForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestion2 methodsFor: 'actions' stamp: 'DiegoLont 8/21/2011 14:53'!
cancel
	editForm := nil.
	self announce: DEGoHome! !

!FOAskQuestion2 methodsFor: 'hooks' stamp: 'StephanEggermont 5/19/2011 22:47'!
children
	^Array with: self editForm! !

!FOAskQuestion2 methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 15:59'!
createEditForm
	^DEEditForm new 
		subject: FOQuestion new isNew: true;
		cancelAction: [self cancel];
		title: '?';
		saveTextNew: 'Post your question';
		saveAction: [self save];
		yourself! !

!FOAskQuestion2 methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 15:52'!
editForm
	editForm ifNil: [editForm := self createEditForm].
	^editForm! !

!FOAskQuestion2 methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 16:10'!
renderContentOn: canvas
	canvas render: self editForm.! !

!FOAskQuestion2 methodsFor: 'actions' stamp: 'DiegoLont 8/21/2011 14:53'!
save
	|question|
	question := self editForm subject.
	question author: self  user.
	FOModel default questions add: question.
	editForm := nil.
	self announce: DEGoHome! !

!FOAskQuestion2 methodsFor: 'hooks' stamp: 'StephanEggermont 5/20/2011 15:15'!
states
	^Array with: self editForm! !

DEComponent subclass: #FOHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 5/19/2011 15:04'!
renderContentOn: canvas
	canvas div 
		class: 'homepage';
		with: [
	self renderQuestionsOn: canvas.]! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 4/29/2011 15:05'!
renderQuestion: aQuestion on: canvas
	(canvas div)
		class: 'question';
		with: [ 
			self renderVotesOf: aQuestion on: canvas.
			self renderSummaryOf: aQuestion on: canvas] ! !

!FOHome methodsFor: 'rendering' stamp: 'DiegoLont 6/29/2011 16:03'!
renderQuestionsOn: canvas
	(FOModel default questions sort: [:a :b | a voteValue > b voteValue ])do: [:each|
		self renderQuestion: each on: canvas]! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 16:19'!
renderSummaryOf: aQuestion on: canvas
	canvas div
		class: 'summary';
		with: [ 
			canvas div 
				class: 'title';
				with: [
			(canvas anchor)
					callback: [ self viewQuestion: aQuestion ];
					with: aQuestion title].
			canvas div
				class: 'contents';
				with: aQuestion content.
			canvas div 
				class: 'author';
				with: aQuestion authorName]
 ! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 23:42'!
renderVotesOf: aQuestion on: canvas
	|nr|
	nr := aQuestion voteSize.
	canvas div
		class: 'votes';
		with: [ 
			canvas div
				class: 'count';
				with: nr.
			nr = 1 ifTrue: [
				canvas div: 'vote'] 
			ifFalse: [			
				canvas div: 'votes' ]]! !

!FOHome methodsFor: 'actions' stamp: 'StephanEggermont 4/28/2011 22:48'!
viewQuestion: aQuestion
	^ self announce: (FOGoViewQuestion on: aQuestion)! !

DEComponent subclass: #FOViewQuestion
	instanceVariableNames: 'question editForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 14:22'!
answerEditForm
	editForm ifNil: [editForm := self createAnswerEditForm].
	^editForm! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 14:44'!
createAnswerEditForm
	^DEEditForm new 
		subject: (FOAnswer new author: self user; yourself) isNew: true;
		cancelAction: [self cancel];
		title: '?';
		saveTextNew: 'Post your answer';
		saveAction: [self save];
		yourself! !

!FOViewQuestion methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 22:19'!
downvote 
	question voteDown: self  user ! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:20'!
renderAnswer: anAnswer on: canvas
	(canvas div)
		class: 'view-answer';
		with: [ 
			self renderAnswer: anAnswer votesOn: canvas.
			self renderAnswerSummaryOf: anAnswer on: canvas.] ! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:04'!
renderAnswer: anAnswer votesOn: canvas
	canvas div
		class: 'votes';
		with: [ 
					canvas anchor
						callback: [ anAnswer upvote ];
						with: [ canvas html: '&#x25b2;' ].
					canvas break.
					canvas
						text: anAnswer voteValue;
						break.
					canvas anchor
						callback: [ anAnswer downvote ];
						with: [ canvas html: '&#x25bc;' ] ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:08'!
renderAnswerSummaryOf: anAnswer on: canvas
	canvas div
		class: 'answer-summary';
		with: [ 
					canvas
						text: anAnswer content;
						break;
						text: anAnswer authorName ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 14:46'!
renderAnswersOn: canvas
	question hasAnswers ifFalse: [^self].
	(canvas div)
		class: 'view-answers';
		with: [ 
			canvas heading 
				level: 1;
				with: question answerSizeString..
			question answers do: [:answer|
				self renderAnswer: answer on: canvas.
				]]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:24'!
renderContentOn: canvas
	canvas div
		class: 'view-question';
		with: [ 
					canvas heading: question title.
					self renderVotesOn: canvas.
					canvas
						text: question content;
						break;
						text: question tagString;
						break;
						text: question authorName.
					self renderAnswersOn: canvas.
					canvas render: self answerEditForm ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 23:41'!
renderVotesOn: canvas
	canvas div
		class: 'votes';
		with: [
	canvas anchor 
		callback: [self upvote];
		with: [canvas html: '&#x25b2;'].
	canvas break.
	canvas
		text: question voteValue;
		break.
	canvas anchor 
		callback: [self downvote];
		with: [canvas html: '&#x25bc;']]
	! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 14:44'!
save
	|answer|
	answer := self answerEditForm subject.
	question answers add: answer.
	
	editForm := nil.
	self announce: DEGoHome! !

!FOViewQuestion methodsFor: 'initialization' stamp: 'StephanEggermont 4/28/2011 22:36'!
subject: aQuestion
	question  := aQuestion! !

!FOViewQuestion methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 22:19'!
upvote
	question voteUp: self  user! !

WAFileLibrary subclass: #FOFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOFileLibrary methodsFor: 'accessing' stamp: 'WillemvandenEnde 10/3/2011 15:20'!
mainCss
	^'
	.topbar{
		width: 960px;
		background-color: #eeeeee;
		height: 30px;
		border: 0;
		margin: 0;
		padding: 0;
	}	
	.hlinks{
		float: right
	}
	.userspan{
		text-align: right;
		font-weight: bold;
		font-size: 12px;
		color: #0077CC;
		padding: 15px 20px 2px 0px;
	}
	
	.metaspan{
		text-align: right;
		font-weight: bold;
		font-size: 12px;
		color: #0077CC;
		padding: 4px 20px 2px 0px;
	}
	body{
		font-family:Arial,Liberation Sans,DejaVu Sans,sans-serif;
		border: 0;
		margin: 0;
		padding: 0;
	
	}
	.page-header .home{
		padding: 40px 10px 10px 10px;;
	}
	.home a{
		font-size: 32px;
		color: #111;
		text-decoration: none;
	}
	.top input{
		background-color: #aaa;
		color: white;
		border: 0;
	}
	.top input:hover{
		background-color: orange;
	}
	.top input.text{
		background-color: #fff;
		color: black;
		border: 1px solid black;
	}
.question{
	float: left;
	border-bottom: 1px dotted #999;
	overflow: hidden;
	width: 730px;
	display: block;
}
.votes{
	display: block;
	float: left;
	width: 38px;
	padding: 5px;
	text-align: center;
}	
.votes a{
	text-decoration: none;
	color: #aaa;
}
.summary{
	float: left;
	width: 550px;
	margin: 5px;
}
.question .count{
	font-size: 190%;
}
.summary .title{
	font-size: 14px;
	height: 20px;
}
.summary a{
	text-decoration: none;
}
.summary .contents{
	height: 30px;
	overflow: hidden;
	font-size: 12px;
}
.summary .author{
	float: right;
	font-size: 12px;
	color: blue;
}
.view-answer {
	padding: 5px;
	border-bottom: 1px solid #aaa;
}
view-answer h2 {
	font-size: 16px;
}
answer-summary{
	float: left;
	width: 550px;
	margin: 5px;
}
.view-question h1{
	padding: 5px;
	font-size: 24px;
	border-bottom: 1px solid #aaa;
}
	'! !

!FOFileLibrary methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 13:45'!
selectorsToInclude
	^#(mainCss)! !

Announcement subclass: #FOGoAllQuestions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoAskQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoAskQuestion2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoViewQuestion
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

!FOGoViewQuestion class methodsFor: 'instance creation' stamp: 'StephanEggermont 4/28/2011 22:40'!
on: aQuestion
	^self new
		question: aQuestion;
		yourself! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question
	^ question! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question: anObject
	question := anObject! !

Object subclass: #FOAuthor
	instanceVariableNames: 'model userName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOAuthor class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/18/2011 16:46'!
on: aModel
	^self basicNew
		initialize: aModel;
		yourself! !

!FOAuthor methodsFor: 'initialization' stamp: 'StephanEggermont 5/18/2011 16:46'!
initialize: aModel
	self initialize.
	model := aModel! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:48'!
model
	^model! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:53'!
newQuestion
	^model newQuestion
		author: self;
		yourself! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:45'!
password
	^ password! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:45'!
password: anObject
	password := anObject! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 15:28'!
userName
	^ userName! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 15:27'!
userName: aUserName
	userName := aUserName! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 1/28/2013 16:05'!
username
	^ userName! !

Object subclass: #FOModel
	instanceVariableNames: 'questions authors tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

FOModel class
	instanceVariableNames: 'default'!

FOModel class
	instanceVariableNames: 'default'!

!FOModel class methodsFor: 'singleton' stamp: 'StephanEggermont 5/18/2011 16:04'!
default
	^default ifNil: [default := self new]! !

!FOModel class methodsFor: 'singleton' stamp: 'StephanEggermont 5/19/2011 16:14'!
reset
	default := nil! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 23:55'!
authorNamed: aName
	|retVal|
	retVal := self authors detect: [:each | each userName = aName] ifNone: [ 	
		|author|
		author := (FOAuthor on: self)
			userName: aName;
			yourself.
		self authors add: author.
		retVal :=author].
	^retVal.! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:48'!
authorNamed: aName password: aPassword
	^self authors detect: [:each |
		 (each userName = aName) and: [each password = aPassword]]
	 ifNone: [ ^nil].
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:45'!
authors
	^authors ifNil: [authors := OrderedCollection new]! !

!FOModel methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 15:53'!
hasQuestion: aQuestion
	^self questions includes: aQuestion! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:08'!
newAuthor
	^self authors add: (FOAuthor on: self)
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
newQuestion
	^self questions add: FOQuestion new
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
newTag
	^self tags add: FOTag new
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 15:16'!
questions
	^questions ifNil: [questions := OrderedCollection new]! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 12:01'!
registerAuthor: aName password: aPassword
	|retVal|
	retVal := self authors detect: [:each | each userName = aName] ifNone: [ 	
		|author|
		author := (FOAuthor on: self)
			userName: aName;
			password: aPassword;
			yourself.
		self authors add: author.
		retVal :=author].
	^retVal.! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:48'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

Object subclass: #FOPost
	instanceVariableNames: 'author votes content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOPost commentStamp: 'StephanEggermont 5/19/2011 11:10' prior: 0!
A F2Post has an author and can be voted on!

FOPost subclass: #FOAnswer
	instanceVariableNames: 'accepted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOAnswer class methodsFor: 'as yet unclassified' stamp: 'WillemvandenEnde 10/3/2011 14:37'!
editFields
	^self fields! !

!FOAnswer class methodsFor: 'as yet unclassified' stamp: 'WillemvandenEnde 10/3/2011 14:37'!
fields
	^#(contentsField)! !

!FOAnswer methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:08'!
accept
	accepted := true.! !

!FOAnswer methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:08'!
accepted
	^accepted ifNil: [^false]! !

FOPost subclass: #FOComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOPost class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 12:39'!
contentsField
	^DEMemoField new
		label: 'Contents';
		accessor: #(content);
		validator: (DEStringValidator new
			beRequired;
			errorMessage: 'Contents is verplicht';
			yourself);
		yourself! !

!FOPost class methodsFor: 'fields' stamp: 'StephanEggermont 5/21/2011 00:01'!
nrOfVotesField
	^DENumberField new
		label: '#votes';
		accessor: #(voteSize);
		beReadonly;
		yourself! !

!FOPost class methodsFor: 'fields' stamp: 'StephanEggermont 5/21/2011 00:03'!
votesField
	^DENumberField new
		label: 'vote';
		accessor: #(voteValue);
		beReadonly;
		yourself! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:08'!
author
	^author! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
author: anAuthor
	author := anAuthor! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:17'!
authorName
	author ifNil: [^'Anonymous'].
	^ author userName! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:38'!
content
	^content! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:38'!
content: aContent
	content := aContent! !

!FOPost methodsFor: 'accessing' stamp: 'DiegoLont 8/4/2011 09:59'!
voteDown: anAuthor
	author ~= anAuthor ifTrue: [
		self votes add: (FOVote down: anAuthor)]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
voteSize
	^self votes size! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
voteUp: anAuthor
	author ~= anAuthor ifTrue: [
		self votes add: (FOVote up: anAuthor)]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:23'!
voteValue
	^self votes inject: 0 into: [:sum :each | sum+ each increment]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
votes
	^votes ifNil: [votes := OrderedCollection new]! !

FOPost subclass: #FOQuestion
	instanceVariableNames: 'answers title tags comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOQuestion class methodsFor: 'fields' stamp: 'StephanEggermont 5/19/2011 16:19'!
editFields
	^self fields! !

!FOQuestion class methodsFor: 'fields' stamp: 'StephanEggermont 5/19/2011 22:00'!
fields
	^#(titleField contentsField)! !

!FOQuestion class methodsFor: 'fields' stamp: 'StephanEggermont 5/21/2011 00:04'!
reportFields
	^#(titleField contentsField nrOfVotesField votesField)! !

!FOQuestion class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 12:39'!
titleField
	^DEStringField new
		label: 'Title';
		accessor: #(title);
		validator: (DEStringValidator new
			beRequired;
			errorMessage: 'Een title is verplicht';
			yourself);
		yourself! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 12:00'!
addTag: aTag
	aTag questions add: self.
	self tags add: aTag! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:40'!
answerSize
	^self answers size! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:43'!
answerSizeString
	self answers size = 1 ifTrue: [^'1 Answer'].
	^self answers size asString,' Answers'! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:10'!
answers
	^answers ifNil: [answers := OrderedCollection new]! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:27'!
canAccept: anAnswer
	^self hasAcceptedAnswer not and: [self answers includes: anAnswer]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 12:11'!
comments
	^comments ifNil: [comments := OrderedCollection new]! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:12'!
hasAcceptedAnswer
	^self answers anySatisfy: [:each |each accepted]! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 12:09'!
hasAnswer: anAnswer
	^self answers includes: anAnswer! !

!FOQuestion methodsFor: 'testing' stamp: 'WillemvandenEnde 10/3/2011 14:13'!
hasAnswers
	 ^answers notNil.! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 12:10'!
hasComment: aComment
	^self comments includes: aComment! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 11:59'!
hasTag: aTag
	^self tags includes: aTag! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:19'!
isAnswered
	^self answers size > 0! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newAnswer
	|answer|
	answer := FOAnswer new.
	self answers add: answer.
	^answer! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newAnswer: anAuthor
	^self answers add: (FOAnswer new
		author: anAuthor;
		yourself).
! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newComment
	^self comments add: FOComment new.
! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 22:22'!
tagString
	^String streamContents: [:s |
		self tags do: [:tag |
			s nextPutAll: tag description] separatedBy: [s space]]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:59'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:32'!
title
	^title! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 15:44'!
title: aTitle
	title := aTitle.
! !

Object subclass: #FOTag
	instanceVariableNames: 'description questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:53'!
description
	^description! !

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:53'!
description: aDescription
	description := aDescription! !

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:55'!
questions
	^questions ifNil: [questions := OrderedCollection new]! !

Object subclass: #FOVote
	instanceVariableNames: 'author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

FOVote subclass: #FODownVote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FODownVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:27'!
increment
	^-1! !

FOVote subclass: #FOUpVote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOUpVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:27'!
increment
	^1! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/19/2011 16:11'!
down: anAuthor
	^FODownVote on: anAuthor! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/18/2011 17:22'!
on: anAuthor
	^self basicNew
		initialize: anAuthor;
		yourself! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/19/2011 16:11'!
up: anAuthor
	^FOUpVote on: anAuthor! !

!FOVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:26'!
increment
	^self subclassResponsibility! !

!FOVote methodsFor: 'initialization' stamp: 'StephanEggermont 5/18/2011 17:23'!
initialize: anAuthor
	self initialize.
	author := anAuthor! !
FOAgileOverflow initialize!
